Subject: Re: CGI apps crashing? (Was: Re: id.exe crashes when using ssh (since 1.1.6?))
From: [email-masked] (Henry S. Thompson)
To: "Rui Carmo" <[email-masked]>
Cc: "cygwin" <[email-masked]>
Date: 03 Jan 2001 16:43:31 +0000

"Rui Carmo" <[email-masked]> writes:

> Well, I have new data on this issue. A number of CGI apps I am using (that
> generate JPEG images based on all kinds of data) stopped working after my
> update (I am using Apache for Win32 on my development box)
> 
> Oddly enough, the CGI binaries work OK when run from a bash prompt, but
> yield corrupted images when run under Apache. None of the binaries was
> recompiled.
> 
> The penny finally dropped when I tried compiling conicplanet
> (http://conic.sourceforge.net/) under cygwin to figure out some
> image-processing code. conicplanet.cgi yields perfect results when run from
> a bash prompt, and multicolored garbage under Apache - exactly the same
> problem my unmodified binaries had...
> 
> So my guess is that we have something afoot inside cygwin1.dll...
> Apparently, it has problems forking a subprocess under anything other than
> the initial user context (hence the crashes on the remote id.exe when I ssh
> to another box, and the misbehaving CGI binaries).
> 
> Anyone here experiencing the same problemas with either ssh or CGI
> executables created with cygwin?

The id.exe crash has been reported several times (I just reproduced it
having upgraded to 1.1.7), but none of us have been able to get enough
info about it to Corinna to enable her to solve the problem, and she
can't reproduce it.  Maybe your additional input will help, but she's
on vacation just now I believe. . .

I tried running sshd -i -d from inetd and looking in the application
event log, but not sure there's anything useful there.  There appeared 
to be some issue with /var/log/lastlog, first not being there, then
after I created it (empty), I see "lastlog_get_entry: Error reading
from /var/log/lastlog: No such file or directory" but when I look at
it it's now 200K of nulls with XSS:tty1...[name of host I tried to
connect _from_] near the end.

All the entries chronologically after that in the event log are

debug1: tvp!=NULL kid 0 mili 10

The application log event messages before that, in reverse order, are:

debug1: server_init_dispatch_15
debug1: server_init_dispatch_13
debug1: fd 8 setting O_NONBLOCK
debug1: fd 7 setting O_NONBLOCK
debug1: Entering interactive session

and everything earlier than that is very similar to what I get from
sshd -d from the command line (which, as you observe, works just fine).

There are slight differences:  from the command line debug I see at
the equivalent point:

debug1: tvp!=NULL kid 0 mili 10
debug1: server_init_dispatch_15
debug1: server_init_dispatch_13
debug1: fd 7 setting O_NONBLOCK
debug1: fd 3 setting O_NONBLOCK
debug1: Entering interactive session

Is the difference between fd 8 and fd 3 significant?

ht 
-- 
  Henry S. Thompson, HCRC Language Technology Group, University of Edinburgh
          W3C Fellow 1999--2001, part-time member of W3C Team
     2 Buccleuch Place, Edinburgh EH8 9LW, SCOTLAND -- (44) 131 650-4440
	    Fax: (44) 131 650-4587, e-mail: [email-masked]
		     URL: http://www.ltg.ed.ac.uk/~ht/

--
Want to unsubscribe from this list?
Check out: http://cygwin.com/ml/#unsubscribe-simple